'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isPropsProperty = exports.isPropsAssignment = exports.isHandledProperty = exports.isHandledAssignment = undefined;

var _babelTypes = require('babel-types');

var t = _interopRequireWildcard(_babelTypes);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

var expectStatic = function expectStatic(key, isStatic) {
  return !isStatic && key.buildCodeFrameError('\'' + key + ' must be defined as static');
};

var isHandledAssignment = exports.isHandledAssignment = function isHandledAssignment(left, right, property) {
  if (!t.isMemberExpression(left) || !t.isIdentifier(property, { name: 'handledProps' })) return false;
  if (!t.isArrayExpression(right)) right.buildCodeFrameError('`handledProps` must be an array');

  return true;
};

var isHandledProperty = exports.isHandledProperty = function isHandledProperty(key, value, isStatic) {
  if (!t.isIdentifier(key, { name: 'handledProps' })) return false;
  if (!t.isArrayExpression(value)) value.buildCodeFrameError('`handledProps` must be an array');
  expectStatic(key, isStatic);

  return true;
};

var isPropsAssignment = exports.isPropsAssignment = function isPropsAssignment(left, right, property) {
  if (!t.isMemberExpression(left)) return false;
  if (!t.isIdentifier(property, { name: 'defaultProps' }) && !t.isIdentifier(property, { name: 'propTypes' })) {
    return false;
  }
  if (!t.isObjectExpression(right)) right.buildCodeFrameError('`defaultProps` and `propTypes` must be an array');

  return true;
};

var isPropsProperty = exports.isPropsProperty = function isPropsProperty(key, value, isStatic) {
  if (!t.isIdentifier(key, { name: 'defaultProps' }) && !t.isIdentifier(key, { name: 'propTypes' })) return false;
  if (!t.isObjectExpression(value)) value.buildCodeFrameError('`defaultProps` and `propTypes` must be object');
  expectStatic(key, isStatic);

  return true;
};