'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.generateExpression = exports.findClassIdentifier = undefined;

var _babelTypes = require('babel-types');

var t = _interopRequireWildcard(_babelTypes);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

var findClassIdentifier = exports.findClassIdentifier = function findClassIdentifier(path) {
  var declaration = path.findParent(function (parentPath) {
    return parentPath.isClassDeclaration();
  });
  return declaration.node.id.name;
};

var generateExpression = exports.generateExpression = function generateExpression(store, identifier) {
  var props = store.get(identifier).map(function (prop) {
    return t.stringLiteral(prop);
  });
  var left = t.memberExpression(t.identifier(identifier), t.identifier('handledProps'));
  var expression = t.assignmentExpression('=', left, t.arrayExpression(props));

  return t.expressionStatement(expression);
};